function benchmark(Q)
% BENCHMARK performs benchmarks used for the results in the paper
%
%   BENCHMARK(Q) runs case Q
%
%   Q:    1 : Tensor with near uniform singular spectrum
%         2-4 : Generic functions #1,2,3 in the paper (#2,3,4 in code)
%         5-8 : Random tensors with exact low rank n = 8,12,16,20
%         9 : Rank adaption test tensor
%
%   The results will be saved in the folder SALSA_Batch_Run. Use show_results
%   to display results as tables. Some tests however take a considerable
%   amount of time to perform. In order to just check codes, one may add the
%   line  'sa',1,...  to reduce the number of trials to 1. The jobs should be
%   executed in parallel on different cores.
%
%   If results strongly deviate from whats given in the paper, please contact
%   me and I will try to resolve the issue.
%
%   Author:
%
%   Written by Sebastian Kraemer, IGPM RWTH Aachen University (2019)
%   In case of problems or questions, feel free to send an email to
%   kraemer@igpm.rwth-aachen.de
%
%   See the license file for copyright issues.
%
%   See also: TEST_SALSA_JOBS, SALSA, SHOW_RESULTS

switch Q
    case 1
        test_SALSA_jobs('Batch_Run/SALSA_domino',...
            'tensortype', 'fct', ...
            'f_name', 'domino', ...
            'r_fin_samp', 6, ...
            'r_fin_add', 8, ...
            'c', {2,4,6}, ...
            'd', {6,9,15}, ...
            'n', {'12*ones(1,para.d)','20*ones(1,para.d)'});
        
    case 2
        test_SALSA_jobs('Batch_Run/SALSA_generic2',...
            'tensortype', 'fct', ...
            'f_name', 'generic2', ...
            'd', 8, ...
            'n', '8*ones(1,para.d)', ...
            'r_fin_samp', 6, ...
            'r_fin_add', 8, ...
            'c', {2,4,6});
        
    case 3
        test_SALSA_jobs('Batch_Run/SALSA_generic3',...
            'tensortype', 'fct', ...
            'f_name', 'generic3', ...
            'd', 7, ...
            'n', '8*ones(1,para.d)', ...
            'r_fin_samp', 6, ...
            'r_fin_add', 8, ...
            'c', {2,4,6});
        
    case 4
        test_SALSA_jobs('Batch_Run/SALSA_generic4',...
            'tensortype', 'fct', ...
            'f_name', 'generic4', ...
            'd', 11, ...
            'n', '8*ones(1,para.d)', ...
            'r_fin_samp', 6, ...
            'r_fin_add', 8, ...
            'c', {2,4,6});
        
    case 5
        test_SALSA_jobs('Batch_Run/SALSA_rnd_tensors_n8',...
            'rec_limit',1e-6, ...
            'c_skip',1, ...
            'tensortype', 'rnd', ...
            'c', {2,4,8,16,32,64}, ...
            'r_rnd', 6, ...
            'd', {5,6,7}, ...
            'n', '8*ones(1,para.d)', ...
            'r_fin_samp', 6, ...
            'r_fin_add', 3);
        
    case 6
        test_SALSA_jobs('Batch_Run/SALSA_rnd_tensors_n12',...
            'rec_limit',1e-6, ...
            'c_skip',1, ...
            'tensortype', 'rnd', ...
            'c', {2,4,8,16,32,64}, ...
            'd', {5,6,7}, ...
            'n', '12*ones(1,para.d)', ...
            'r_rnd', {6,8}, ...
            'r_fin_samp', 'para.r_rnd', ...
            'r_fin_add', 3);
        
    case 7
        test_SALSA_jobs('Batch_Run/SALSA_rnd_tensors_n16',...
            'rec_limit',1e-6, ...
            'c_skip',1, ...
            'tensortype', 'rnd', ...
            'c', {2,4,8,16,32,64}, ...
            'd', {5,6,7}, ...
            'n', '16*ones(1,para.d)', ...
            'r_rnd', {6,8}, ...
            'r_fin_samp', 'para.r_rnd', ...
            'r_fin_add', 3);
        
    case 8
        test_SALSA_jobs('Batch_Run/SALSA_rnd_tensors_n20',...
            'rec_limit',1e-6, ...
            'c_skip',1, ...
            'tensortype', 'rnd', ...
            'c', {2,4,8,16,32,64}, ...
            'd', {5,6,7}, ...
            'n', '20*ones(1,para.d)', ...
            'r_rnd', {6,8}, ...
            'r_fin_samp', 'para.r_rnd', ...
            'r_fin_add', 3);
        
    case 9
        test_SALSA_jobs('Batch_Run/SALSA_spc_tensor',...
            'rec_limit',1e-6, ...
            'c_skip',1, ...
            'tensortype', 'spc', ...
            'c', {2,4,8,16,32,64}, ...
            'r_rnd', {2,3,4}, ...
            'd', 6, ...
            'n', {'12*ones(1,para.d)','20*ones(1,para.d)'}, ...
            'r_fin_samp', '2*para.r_rnd', ...
            'r_fin_add', 3);
end

